iv.modelviews = function (wnd, panel) {
    this.wnd = wnd;
    this.active = null;
    this.views = [];
    if (panel) this.panel = panel;
    else this.panel = document.getElementById("modelviewspanel");
    var p = this;
    wnd.addRefTarget(function (event) {
        p.onNotify(event);
    });
}

iv.modelviews.prototype.onNotify = function (event)
{
        switch (event.code) {
            case "dataReady": 
                {
                    this.fillModelView(event.space);
                } break;
        }
}
iv.modelviews.prototype.fillModelView=function(space) {
    var _i = space.views;
    
    if (_i && _i.length) {
        //panel.style.bottom = "0px";
        for (var i = 0; i < _i.length; i++) {
            var v = _i[i];

            var view = this.makeViewButton(v);

            //makeViewButton(view, wnd, v);
            var item = document.createElement("h2");
            item.innerHTML = v.name;
            view.appendChild(item);

            if (v.description) {
                var item = document.createElement("em");
                item.innerHTML = v.description;
                view.appendChild(item);
            }

            item = document.createElement("div");
            item.className = "NavRightCell";
            view.playButton=this.makePlayButton(item, view);
            view.appendChild(item);
        }
    }
}

iv.modelviews.prototype.setActiveBtn = function (d, active) {
    d.style.background = active ? "rgba(53,55,67,0.8)" : "";
    d.playButton.style.opacity = active ? "1.0" : "";

}
iv.modelviews.prototype.activate = function (v, mode) {
    //this.wnd.setModelView(v, iv.VIEW_TRANSITION | iv.VIEW_ANIM_SET);
    if (this.active != v) {
        if (this.active) this.setActiveBtn(this.active, false);
        this.active = v;
        if (v) this.setActiveBtn(v, true);
    }
    if (v) {
        var flags = iv.VIEW_TRANSITION | iv.VIEW_ANIM_SET;
        if (mode) flags |= iv.VIEW_ANIM_PLAY;
        this.wnd.setModelView(v.ivModelView, flags);
    }
}

iv.modelviews.prototype.makeViewButton=function(v) {
    var view=document.createElement("div");
    view.ivModelView=v;
    this.views.push(view);
    view.className = "view";
    var p=this;
    view.onclick = function (){p.activate(view,0);};
    this.panel.appendChild(view);
    return view;
}
iv.modelviews.prototype.makePlayButton = function (panel, v) {
    var item = document.createElement("span");
    item.innerHTML = " Play ";
    item.className = "flatButton";
    panel.appendChild(item);
    var p = this;
    item.onclick = function (event) { event.stopPropagation(); p.activate(v, 1);};
    return item;
}